#include "../../kdm2/header.h"

using namespace std;

bool isReflexive(short** matrix, short n) {for (short a=0;a<n;a++)if (!matrix[a][a])return 0;return 1;}
bool isAntireflexive(short** matrix, short n) {for (short a=0;a<n;a++)if (matrix[a][a])return 0;return 1;}
bool isSymmetric(short** matrix, short n) {for (short a=0;a<n;a++)for(short b=a;b<n;b++)if (matrix[a][b]!=matrix[b][a])return 0;return 1;}
bool isAntiSymmetric(short** matrix, short n) {for (short a=0;a<n;a++)for(short b=a;b<n;b++)if (matrix[a][b]&&matrix[a][b]==matrix[b][a])return 0;return 1;}
bool isAsymmetric(short** matrix, short n){short counter=0;for (short a=0;a<n;a++)for(short b=a;b<n;b++)if (matrix[a][b]==matrix[b][a])counter++;if (counter>0&&counter!=n)return 1;return 0;}
bool isTransitive(short** matrix, short n) {for (short i=0;i<n;i++)for(short j=0;j<n;j++)if(matrix[i][j])for(short k=0;k<n;k++)if(matrix[j][k]&& !matrix[i][k])return 0;return 1;}
bool isAntitransitive(short** matrix, short n) {for (short i=0;i<n;i++)for(short j=0;j<n;j++)if(matrix[i][j])for(short k=0;k<n;k++)if(matrix[j][k]&&matrix[i][k])return 0;return 1;}
short** printcomps(short** a, short** b, short n=3) {short** matrix=new short*[n];
    for (short i=0; i<n; i++) {
        matrix[i]=new short[n];
        for (short k=0; k<n; k++)matrix[i][k] = 0;}
    for (short i=0;i<n;i++)for(short j=0;j<n;j++)for(short k=0;k<n;k++)matrix[i][j]+=a[i][k]&&b[k][j];return matrix;}

#define isOrder(matrix,n)(isAntireflexive(matrix,n)&&isTransitive(matrix,n)&&isAntiSymmetric(matrix,n))
#define isEquivalence(matrix,n)(isReflexive(matrix,n)&&isSymmetric(matrix,n)&&isTransitive(matrix,n))
#define isTolerance(matrix,n)(isReflexive(matrix,n)&&isAntitransitive(matrix,n)&&isSymmetric(matrix,n))
int main() {
    string input;
    cout << "Enter adjacency matrix or enter matrix size for adjacency list. Do not separate anything with anything."<<endl;
    cin>>input;
    if (stoi(input)<2 && input.length()<2){cout<<"incorrent input."<<endl;return 1;}
    short n;
    bool crazy=0;
    if (input[0]<50)n = input.length();else {n=input[0]-48;crazy=1;cout<<"Adjacency list mode (use letters). Enter 0 to finish input"<<endl;}
    short **first=enter(input,n,1,crazy,1);
    display(first,1,n,0,"Entered relationships:",1);
    cout<<"The relation is ";if(!isReflexive(first,n))cout<<"not ";cout<<"reflexive"<<endl;
    cout<<"The relation is ";if(!isAntireflexive(first,n))cout<<"not ";cout<<"antireflexive"<<endl;
    cout<<"The relation is ";if(!isSymmetric(first,n))cout<<"not ";cout<<"symmetric"<<endl;
    cout<<"The relation is ";if(!isAntiSymmetric(first,n))cout<<"not ";cout<<"antisymmetric"<<endl;
    cout<<"The relation is ";if(!isAsymmetric(first,n))cout<<"not ";cout<<"asymmetric"<<endl;
    cout<<"The relation is ";if(!isTransitive(first,n))cout<<"not ";cout<<"transitive"<<endl;
    cout<<"The relation is ";if(!isAntitransitive(first,n))cout<<"not ";cout<<"antitransitive"<<endl;
    cout<<"The relation is ";if(!isEquivalence(first,n))cout<<"not ";cout<<"equivalence"<<endl;
    cout<<"The relation is ";if(!isTolerance(first,n))cout<<"not ";cout<<"tolerance"<<endl;
    cout<<"The relation is ";if(!isOrder(first,n))cout<<"not ";cout<<"order"<<endl;
    cout << "Enter second matrix or enter matrix size for adjacency list. Do not separate anything with anything."<<endl;
    cin>>input;
    if (stoi(input)<2 && input.length()<2){cout<<"incorrent input."<<endl;return 1;}
    if (input[0]>49){crazy=1;cout<<"Adjacency list mode (use letters). Enter 0 to finish input"<<endl;}
    short **second=enter(input,3,1,crazy,1);
    display(second,1,3,0,"Entered matrix:",1);
    short **one=printcomps(first,second);
    display(one,1,3,0,"first*second:",1);
    one=printcomps(second,first);
    display(one,1,3,0,"second*first:",1);
    for (short a=0;a<n;a++)free(first[a]);free(first);return 0;
}
